﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Bots.Professionbuddy;
using Styx;
using Styx.Common.Helpers;
using Styx.CommonBot.Coroutines;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;

namespace HighVoltz.AutoAngler
{
	static partial class Coroutines
	{
		private readonly static WaitTimer LureRecastTimer = WaitTimer.TenSeconds;

		private const int AncientPandarenFishingCharmItemId = 85973;

		private const int AncientPandarenFishingCharmAuraId = 125167;

	    private const int WormSupremeItemId = 118391;

	    private const int WormSupremeAuraId = 174471;

        private static readonly Dictionary<uint, string> DraenorLures = new Dictionary<uint, string>
																{
																	{110291, "Fire Ammonite Bait"},
																	{110290, "Blind Lake Sturgeon Bait"},
																	{110292, "Sea Scorpion Bait"},
																	{110274, "Jawless Skulker Bait"},
																	{110293, "Abyssal Gulper Eel Bait"},
																	{110289, "Fat Sleeper Bait"},
																	{110294, "Blackwater Whiptail Bait"},
																	{114628, "Icespine Stinger Bait"},
																	{114874, "Moonshell Claw Bait"},
																};

		private static readonly Dictionary<uint, string> CommonLures = new Dictionary<uint, string>
																{
																	{68049, "Heat-Treated Spinning Lure"},
																	{62673, "Feathered Lure"},
																	{34861, "Sharpened Fish Hook"},
																	{46006, "Glow Worm"},
																	{6533, "Aquadynamic Fish Attractor"},
																	{7307, "Flesh Eating Worm"},
																	{6532, "Bright Baubles"},
																	{6530, "Nightcrawlers"},
																	{6811, "Aquadynamic Fish Lens"},
																	{6529, "Shiny Bauble"},
																	{67404, "Glass Fishing Bobber"},
																};

		// does nothing if no lures are in bag
		public async static Task<bool> Applylure()
		{
            
            if (StyxWoW.Me.IsCasting)
				return false;

			if (!LureRecastTimer.IsFinished)
				return false;
			
			LureRecastTimer.Reset();
			var mainHand = StyxWoW.Me.Inventory.Equipped.MainHand;

			if (mainHand == null || mainHand.ItemInfo.WeaponClass != WoWItemWeaponClass.FishingPole)
				return false;

            // Worm Supreme
            var wormSupreme = StyxWoW.Me.BagItems.FirstOrDefault(r => r.Entry == WormSupremeItemId);
            if (wormSupreme != null && !StyxWoW.Me.HasAura(WormSupremeAuraId) && !IsLureOnPole)
            {
                AutoAnglerBot.Log("Applying Worm Supreme to Fishing Pole");
                wormSupreme.Use();
                await CommonCoroutines.SleepForLagDuration();
                return true;
            }

			// Ancient Pandaren Fishing Charm
			var ancientPandarenFishingCharm = StyxWoW.Me.BagItems
				.FirstOrDefault(r => r.Entry == AncientPandarenFishingCharmItemId);

            if (ancientPandarenFishingCharm != null && !StyxWoW.Me.HasAura(AncientPandarenFishingCharmAuraId) && IsLureOnPole)
			{
				AutoAnglerBot.Log("Applying Ancient Pandaren Fishing Charm to Fishing Pole");
				ancientPandarenFishingCharm.Use();
				await CommonCoroutines.SleepForLagDuration();
				return true;
			}
		    
            // Fishing Hats
			WoWItem head = StyxWoW.Me.Inventory.Equipped.Head;

            if (head != null && Utility.FishingHatIds.Contains(head.Entry) && !IsLureOnPole)
			{
				AutoAnglerBot.Log("Appling Fishing Hat To Fishing Pole");
				head.Use();
				await CommonCoroutines.SleepForLagDuration();
				return true;
			}

            if (StyxWoW.Me.CurrentMap.ExpansionId == 5 && !IsDraenorLureOnPole)
            {
                UseDraenorLure();
                return true;
            }

		    if (!IsLureOnPole)
		    {
                foreach (var lure in CommonLures)
                {
                    var lureInBag = Utility.GetItemInBag(lure.Key);
                    if (lureInBag != null && lureInBag.Use())
                    {
                        AutoAnglerBot.Log("Appling {0} to Fishing Pole", lure.Value);
                        await CommonCoroutines.SleepForLagDuration();
                        return true;
                    }
                } 
		    }
            

		    return false;

		}

	    private static bool UseDraenorLure()
	    {
            var luresInBag = new Dictionary<uint, string>();

            foreach (var lure in DraenorLures)
            {
                var lureInBag = Utility.GetItemInBag(lure.Key);
                if (lureInBag != null)
                {
                    luresInBag.Add(lure.Key, lure.Value);
                }

            }

	        if (luresInBag.Count > 0)
	        {
	            var randomElement = new Random();
	            var randomLure = luresInBag.ElementAt(randomElement.Next(0, luresInBag.Count));
	            AutoAnglerBot.Log("Appling {0} to Fishing Pole", randomLure.Value);
	            Utility.GetItemInBag(randomLure.Key).Use();
	            return true;
	        }

	        return false;
            
	    }

	    public static bool IsDraenorLureOnPole
	    {
	        get
	        {
	            return DraenorLures.Any(draenorLure => Me.HasAura(draenorLure.Value)); 
	        }
	    }

		public static bool IsLureOnPole
		{
			get
			{
				bool useHatLure = false;

				var head = StyxWoW.Me.Inventory.GetItemBySlot((uint)WoWEquipSlot.Head);
				if (head != null && Utility.FishingHatIds.Contains(head.Entry))
					useHatLure = true;

			    var wormSupreme = StyxWoW.Me.BagItems.FirstOrDefault(r => r.Entry == WormSupremeItemId);
                if (AutoAnglerSettings.Instance.Poolfishing && wormSupreme != null && !StyxWoW.Me.HasAura(WormSupremeAuraId))
                {
                    return false;
                }

				var ancientPandarenFishingCharm = StyxWoW.Me.BagItems.FirstOrDefault(r => r.Entry == AncientPandarenFishingCharmItemId);
				if (AutoAnglerSettings.Instance.Poolfishing && ancientPandarenFishingCharm != null && !StyxWoW.Me.HasAura(AncientPandarenFishingCharmAuraId))
				{
					return false;
				}

				//if poolfishing, dont need lure say we have one
				if (AutoAnglerSettings.Instance.Poolfishing && !useHatLure && !AutoAnglerBot.Instance.Profile.FishAtHotspot)
					return true;

				var ret = Lua.GetReturnValues("return GetWeaponEnchantInfo()");
				return ret != null && ret.Count > 0 && ret[0] == "1";
			}
		}

	}
}
